## rttr 0.9.6%2Bdfsg1

=== debian/changelog ===
rttr (0.9.6+dfsg1-1~mx19+1) mx; urgency=medium

  * Rebuild for MX 19.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 10 Jun 2019 12:07:04 -0700

rttr (0.9.6+dfsg1-1) unstable; urgency=medium

  * Initial release.
    Closes: #928007

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 02 May 2019 12:13:01 +0200
