=== debian/control ===
Source: rttr
Section: libs
Priority: optional
Homepage: https://www.rttr.org/
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Build-Depends: debhelper (>= 10.2),
 cmake,
 libboost-all-dev,
 rapidjson-dev
Standards-Version: 4.3.0

Package: librttr-core0.9.6
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 ${shlibs:Depends}
Multi-Arch: same
Description: C++ reflection library
 RTTR stands for Run Time Type Reflection. It describes the ability of a
 computer program to introspect and modify an object at runtime. It is also
 the name of the library itself, which is written in C++ and released as open
 source library.
 .
 This package contains the shared library.

Package: librttr-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${misc:Depends},
 librttr-core0.9.6 (= ${binary:Version})
Multi-Arch: same
Description: C++ reflection library (development headers)
 RTTR stands for Run Time Type Reflection. It describes the ability of a
 computer program to introspect and modify an object at runtime. It is also
 the name of the library itself, which is written in C++ and released as open
 source library.
 .
 This package contains the development libraries and headers.
