## rttr 0.9.6+dfsg1

=== debian/changelog ===
rttr (0.9.6+dfsg1-3build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:25:24 +0100

rttr (0.9.6+dfsg1-3) unstable; urgency=medium

  * Bump Standards-Version to 4.5.0.
  * Use the new debhelper-compat notation, and drop the d/compat file.
  * Adjust source lintian-overrides.
  * Set Rules-Requires-Root: no.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 23 Jan 2020 16:33:18 +0100

rttr (0.9.6+dfsg1-2) unstable; urgency=medium

  * Bump Standards-Version to 4.4.0.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 23 Jul 2019 11:44:18 +0200
