=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: libs
 Priority: optional
 Homepage: https://www.rttr.org/
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Patrick Matthäi <pmatthaei@debian.org>
-Build-Depends: debhelper (>= 10.2),
+Maintainer: Patrick Matthäi <pmatthaei@debian.org>
+Build-Depends: debhelper-compat (= 12),
  cmake,
  libboost-all-dev,
  rapidjson-dev
-Standards-Version: 4.3.0
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 
 Package: librttr-core0.9.6
 Architecture: any
