=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_CMAKE_PREFIX = /usr
BASE_CMAKE_DEFS = -DCMAKE_BUILD_TYPE=Release -DBUILD_UNIT_TESTS=false -DUSE_PCH=false -DBUILD_BENCHMARKS=false -DBUILD_EXAMPLES=false

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=$(DEB_CMAKE_PREFIX) \
		$(BASE_CMAKE_DEFS) \
		-DCMAKE_CXX_FLAGS="$(CXXFLAGS)"
