=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d// \
https://github.com/rttrorg/rttr/releases \
/rttrorg/rttr/releases/download/v.+/rttr-(.+)-src\.tar\.gz
